Arch Space

From FreeCAD Documentation
Jump to: navigation, search

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎română • ‎русский • ‎svenska • ‎українська
Arrow-left.svg Previous: Arch Roof.svg Roof
Next: Stairs Arch Stairs.svg Arrow-right.svg

Arch Space.svg Arch Space

Menu location
Arch → Space
Workbenches
Arch
Default shortcut
S P
Introduced in version
0.14
See also
Arch Wall, Arch Structure


Description

The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.

Arch Space example.jpg

Space object created from an existing solid object, then two wall faces are added as boundaries.


How to use

  1. Select an existing solid object, or faces on boundary objects.
  2. Press the Arch Space.svg Arch Space button, or press S, P keys.

Limitations

Properties

  • DATABase: The base object, if any (must be a solid)
  • DATABoundaries: A list of optional boundary elements
  • DATAArea: The computed floor area of this space
  • DATAFinishFloor: The finishing of the floor of this space
  • DATAFinishWalls: The finishing of the walls of this space
  • DATAFinishCeiling: The finishing of the ceiling of this space
  • DATAGroup: Objects that are included inside this space, such as furniture
  • DATASpaceType: The type of this space
  • DATAFloorThickness: The thickness of the floor finish
  • DATANumberOfPeople: The number of people who typically occupy this space
  • DATALightingPower: The electric power needed to light this space in Watts
  • DATAEquipmentPower: The electric power needed by the equipment of this space in Watts
  • DATAAutoPower: If True, Equipment Power will be automatically filled by the equipment included in this space
  • DATAConditioning: The type of air conditioning of this space
  • DATAInternal: Specifies if this space is internal or external
  • VIEWText: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
  • VIEWFontName: The name of the font
  • VIEWTextColor: The color of the text
  • VIEWFontSize: The size of the text
  • VIEWFirstLine: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
  • VIEWLineSpacing: The space between the lines of text
  • VIEWTextPosition: The position of the text. Leave (0,0,0) for automatic position
  • VIEWTextAlign: The justification of the text
  • VIEWDecimals: The number of decimals to use for calculated texts
  • VIEWShowUnit: Show the unit suffix or not

Options

  • To create zones that group several spaces, use a Arch BuildingPart and set its IFC type to "Spatial Zone"
  • The space object has the same display modes as other Arch and Part objects, with one more, called Footprint, that displays only the bottom face of the space. introduced in version 0.19

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Space tool can be used in macros and from the Python console by using the following function:

Space = makeSpace(objects=None, baseobj=None, name="Space")
  • Creates a Space object from the given objects or baseobj, which can be
    • one document object, in which case it becomes the base shape of the space object, or
    • a list of selection objects as returned by FreeCADGui.Selection.getSelectionEx(), or
    • a list of tuples (object, subobjectname)

Example:

import FreeCAD, Arch

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000

Space = Arch.makeSpace(Box)
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()

After a space object is created, selected faces can be added to it with the following code:

import FreeCAD, FreeCADGui, Draft, Arch

points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

# Select a face of the wall
selection = FreeCADGui.Selection.getSelectionEx()
Arch.addSpaceBoundaries(Space, selection)

Boundaries can also be removed, again by selecting the indicated faces:

selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)
Arrow-left.svg Previous: Arch Roof.svg Roof
Next: Stairs Arch Stairs.svg Arrow-right.svg